USE [StackOverflow2010]
GO


SELECT TOP 5 [Title]
	,[ViewCount]
	,[AnswerCount]
	,[FavoriteCount]
	,[OwnerUserId]
FROM dbo.Posts p
ORDER BY ViewCount DESC
FOR JSON AUTO;


--JOIN the Users table
SELECT TOP 5 p.[Title]
    ,p.[ViewCount]
    ,p.[AnswerCount]
    ,p.[FavoriteCount]
    ,u.[Id]
    ,u.[DisplayName]
    ,u.[Reputation]
FROM dbo.Posts p
INNER JOIN dbo.Users u ON u.Id = p.OwnerUserId
ORDER BY p.[ViewCount] DESC
FOR JSON AUTO;


SELECT TOP 5 p.[Title]
    ,p.[ViewCount]
    ,p.[AnswerCount]
    ,p.[FavoriteCount]
    ,UserInfo.[Id]
    ,UserInfo.[DisplayName]
    ,UserInfo.[Reputation]
FROM dbo.Posts p
INNER JOIN dbo.Users UserInfo ON UserInfo.Id = p.OwnerUserId
ORDER BY p.[ViewCount] DESC
FOR JSON AUTO;


SELECT TOP 5 p.[Title]
    ,p.[ViewCount]
    ,p.[AnswerCount]
    ,p.[FavoriteCount]
    ,UserInfo.[Id]
    ,UserInfo.[DisplayName]
    ,UserInfo.[Reputation]
    ,PostTypes.[Type]
FROM dbo.Posts p
INNER JOIN dbo.Users UserInfo ON UserInfo.Id = p.OwnerUserId
INNER JOIN dbo.PostTypes PostTypes ON PostTypes.Id = p.PostTypeId
ORDER BY p.[ViewCount] DESC
FOR JSON AUTO;


SELECT TOP 5 p.[Title]
    ,p.[ViewCount]
    ,p.[AnswerCount]
    ,p.[FavoriteCount]
    ,UserInfo.[Id]
    ,UserInfo.[DisplayName]
    ,UserInfo.[Reputation]
    ,PostTypes.[Type]
    ,Votes.CreationDate
FROM dbo.Posts p
INNER JOIN dbo.Users UserInfo ON UserInfo.Id = p.OwnerUserId
INNER JOIN dbo.PostTypes PostTypes ON PostTypes.Id = p.PostTypeId
LEFT JOIN dbo.Votes Votes ON Votes.PostId = p.Id
ORDER BY p.[ViewCount] DESC
FOR JSON AUTO;