USE [StackOverflow2010]
GO

--Create Indexes to support JSON-DEMO queries;
CREATE NONCLUSTERED INDEX [IX_Posts_OwnerUserId_PostTypeId] ON [dbo].[Posts] ([OwnerUserId],[PostTypeId]);

CREATE NONCLUSTERED INDEX [IX_Posts_Counts] ON [dbo].[Posts] ([OwnerUserId],[ViewCount],[AnswerCount],[FavoriteCount],[Score],[PostTypeId])
INCLUDE ([Title]);

CREATE NONCLUSTERED INDEX [IX_Posts_ViewCounts] ON [dbo].[Posts] ([ViewCount] DESC,[OwnerUserId],[PostTypeId])
INCLUDE ([Title],[AnswerCount],[FavoriteCount]);

CREATE NONCLUSTERED INDEX [IX_Users_Info] ON [dbo].[Users] ([Id],[DisplayName], [Reputation]);

CREATE NONCLUSTERED INDEX [IX_Users_Rep_Info] ON [dbo].[Users] ([Reputation] DESC,[DisplayName],[Views], UpVotes, DownVotes);

CREATE NONCLUSTERED INDEX [IX_Votes_PostId_CreationDate] ON [dbo].[Votes] ([PostId],[CreationDate]);
